//+------------------------------------------------------------------+
//|                                                 Coach StdDev.mq4 |
//|                                          Copyright  2009, Coach |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Coach"
#property link      ""

///
///Please, do not sell this EA because its FREE
///Thanks to the help of programmers at www.forexfactory.com for help in guiding me through this project
///Zen Leow for setting up the base for the indicator that this system uses, MA+StdDev and MA-StdDev
///Ronald Raygun for advice on how to reconfigure functions for ticket recognition
///Magnumfreak for continuous input and for helping me get the random number correct
///thatwasme for helping me clean up the code and making it more readable
///This project idea first derived from NanningBob's 60x90 system, but has been converted to a different style that I feel is more adaptable to the market

double xecn=1; //this is used in the feature I added to check for digits and adjust inputs dynamically

extern string  sb="--TRADE SETTING--";
extern int    MA_Period=1440;       // Used to measure periods for MA and StdDev

extern string  magicnumber="--MAgic No--";
extern int MagicNumber=313124;     // Magic number for the orders placed

string mm="-- Money Management--";
extern double Lots = 0.1;
extern bool UseMoneyManagement = true; //Use Money Management or not
extern bool AccountIsMicro = false; //Use Micro-Account or not
extern int Risk = 1; //1%

string  th="--Trade Hours--";
extern bool UseHourTrade = true;
extern int FromHourTrade = 0;
extern int ToHourTrade = 24;
extern bool TradeOnFriday=False; 
color ArrowsColorBuy=Green;             // color for the buy orders arrow
color ArrowsColorSell=Red;             //color for the sell orders arrow
int  slippage=3;
int takeprofitupper=22;
int takeprofitlower=11;
double tp;
string line1comment, line2comment, line3comment, line4comment;
int line1trades=0, line2trades=0, line3trades=0, line4trades=0;
int ticket;
double MA_Line;
double S_Line1;
double S_Line2;
double S_Line3;
double S_Line4;
double U_StopLoss;
double L_StopLoss;
double B_Line1;
double B_Line2;
double B_Line3;
double B_Line4;
double StochBuyLine;
double StochSellLine;
bool Tradeable = true; // function for this needs to be created
datetime LastOrderOpenTime=0;
double rand;
int cnt=0;

void digit_check()
{
 {  if(Digits==3||Digits==5){xecn=10; takeprofitupper = takeprofitupper * xecn; takeprofitlower = takeprofitlower * xecn;}
 }
return;
}



//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
digit_check();
MathSrand(TimeLocal());

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----
MA_Line=iCustom(NULL,0,"MA+StdDev",MA_Period, 1, 6, 0, 0,0);
S_Line1=iCustom(NULL,0,"MA+StdDev",MA_Period, 1, 6, 0, 1,0);
S_Line2=iCustom(NULL,0,"MA+StdDev",MA_Period, 1, 6, 0, 2,0);
S_Line3=iCustom(NULL,0,"MA+StdDev",MA_Period, 1, 6, 0, 3,0);
S_Line4=iCustom(NULL,0,"MA+StdDev",MA_Period, 1, 6, 0, 4,0);
U_StopLoss=iCustom(NULL,0,"MA+StdDev",MA_Period, 1, 6, 0,5,0);
L_StopLoss=iCustom(NULL,0,"MA-StdDev",MA_Period, 1, 6, 0,5,0);
B_Line1=iCustom(NULL,0,"MA-StdDev",MA_Period, 1, 6, 0, 1,0);
B_Line2=iCustom(NULL,0,"MA-StdDev",MA_Period, 1, 6, 0, 2,0);
B_Line3=iCustom(NULL,0,"MA-StdDev",MA_Period, 1, 6, 0, 3,0);
B_Line4=iCustom(NULL,0,"MA-StdDev",MA_Period, 1, 6, 0, 4,0);
StochBuyLine = iStochastic(Symbol(),0,14,3,3,1,1,0,0);
StochSellLine = iStochastic(Symbol(),0,14,3,3,1,1,1,0);  
//----

//Check/Reset Orders
CheckAndReset();

//Open Orders
OpenMarketOrders();

//Check/Manage Open Orders
CloseMarketOrders();

//+------------------------------------------------------------------+

return(0);
}
  
   
//+------------------------------------------------------------------+
//functions

//string CommentKeeper[8]= {"Line1 Buy","Line2 Buy", "Line3 Buy", "Line4 Buy", "Line1 Sell", "Line2 Sell", "Line3 Sell", "Line4 Sell";}



int CheckTicket (string OrderComments)
     {
     for (int i = 0; i < OrdersTotal(); i++)
          {
          if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
               {
               if(OrderComment() == OrderComments) return(OrderTicket());
               }
          }
     } 


void CheckAndReset()
{
   if ((CheckTicket(line1comment)<=0))
   {  
      line1trades = 0;
   }
   if ((CheckTicket(line2comment)<=0))
   {  
      line2trades = 0;
   }
   if ((CheckTicket(line3comment)<=0))
   {  
      line3trades = 0;
   }
   if ((CheckTicket(line4comment)<=0))
   {  
      line4trades = 0;
   }
   return;
}


double LotSize()
{
     double lotMM = MathCeil(AccountFreeMargin() *  Risk / 1000) / 100;
     return (lotMM*xecn);
}

void CloseMarketOrders()
{
   int numberOfOrders = OrdersTotal();
   if (numberOfOrders > 0)
     { for (int cnt=OrdersTotal()-1; cnt >= 0; cnt--)
        {
           if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==false)
	        {if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
	           {
               if (OrderType()==OP_BUY)
                {  if  ((Open[0] > L_StopLoss) && (Close[0] <= L_StopLoss))
                   //while (line4trades>0 || line3trades>0 || line2trades>0 || line1trades>0)
                   //if (OrderSelect(OrderTicket(), SELECT_BY_TICKET, MODE_TRADES)) 
                   { if (OrderComment() == "Coach Line4Buy") line4trades=0;
                     if (OrderComment() == "Coach Line3Buy") line3trades=0;
                     if (OrderComment() == "Coach Line2Buy") line2trades=0;
                     if (OrderComment() == "Coach Line1Buy") line1trades=0;
                     OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),3,Blue);
                     Print(GetLastError());
                   }
                   return;
                }    
             }      
                        
              if (OrderType()==OP_SELL)
                { if  ((Open[0] < U_StopLoss) && (Close[0] >= U_StopLoss))
                  //while (line4trades>0 || line3trades>0 || line2trades>0 || line1trades>0)
                  //if (OrderSelect(OrderTicket(), SELECT_BY_TICKET, MODE_TRADES))
                  {  if (OrderComment() == "Coach Line1Sell") line4trades=0;
                     if (OrderComment() == "Coach Line2Sell") line3trades=0;
                     if (OrderComment() == "Coach Line3Sell") line2trades=0;
                     if (OrderComment() == "Coach Line4Sell") line1trades=0;
                     OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),3,Blue);
                     Print(GetLastError());
                  }   
                  return;
                }
            }
         }    
      }
      return;
}






void OpenMarketOrders()
{
 
   double LotSize = LotSize();
    
   if (LotSize()<0.01) LotSize=0.01*xecn;
   if (LotSize()>100) LotSize=100*xecn; 
   
   if (Tradeable==true)
      {
         if (Bid < MA_Line)
         { 
            if  ((line4trades<1) && (StochBuyLine>=StochSellLine && StochBuyLine<=12)  && ( (Open[0] < B_Line4 && Close[0] >= B_Line4)||(Open[0] > B_Line4 && Close[0] <= B_Line4)))
                  {  
                     tp = 0;
                     LotSize= 0;
                     LotSize = LotSize();
                     rand = MathRand();
                     tp = (takeprofitlower + ((takeprofitupper-takeprofitlower)*(rand/32767)));
                     tp = NormalizeDouble(tp,0); 
                     ticket = OrderSend(Symbol(),OP_BUY,LotSize*6, Ask, 3, 0, 0, "Coach Line4Buy",MagicNumber,0,Green); 
                     if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES))
                        {  
                           Print("BUY order opened : ",OrderOpenPrice());
                        }
                     else
                        {  
                           Print("Error opening BUY order : ",GetLastError());
                        }
                     OrderModify(OrderTicket(),OrderOpenPrice() ,0,Ask+tp*Point,0,Green);
                     line4trades = 1;
                     line4comment = OrderComment();
                     return;
                  } 
                 
      
            if  ((line3trades<1) && (StochBuyLine>=StochSellLine && StochBuyLine<=12)  && ( (Open[0] < B_Line3 && Close[0] >= B_Line3)||(Open[0] > B_Line3 && Close[0] <= B_Line3)))
                  {  
                     tp = 0;
                     LotSize= 0;
                     LotSize = LotSize();
                     rand = MathRand();
                     tp = (takeprofitlower + ((takeprofitupper-takeprofitlower)*(rand/32767)));
                     tp = NormalizeDouble(tp,0); 
                     ticket = OrderSend(Symbol(),OP_BUY,LotSize*3, Ask, 3, 0, 0, "Coach Line3Buy",MagicNumber,0,Green); 
                     if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES))
                        {  
                           Print("BUY order opened : ",OrderOpenPrice());
                        }
                     else
                        {  
                           Print("Error opening BUY order : ",GetLastError());
                        }
                     OrderModify(OrderTicket(),OrderOpenPrice() ,0,Ask+tp*Point,0,Green);
                     line3trades = 1;
                     line3comment = OrderComment();
                     return;
                  } 
                 
            if  ((line2trades<1) && (StochBuyLine>=StochSellLine && StochBuyLine<=12)  && ( (Open[0] < B_Line2 && Close[0] >= B_Line2)||(Open[0] > B_Line2 && Close[0] <= B_Line2)))
                  {  
                     tp = 0;
                     LotSize= 0;
                     LotSize = LotSize();
                     rand = MathRand();
                     tp = (takeprofitlower + ((takeprofitupper-takeprofitlower)*(rand/32767)));
                     tp = NormalizeDouble(tp,0); 
                     ticket = OrderSend(Symbol(),OP_BUY,LotSize*2, Ask, 3, 0, 0, "Coach Line2Buy",MagicNumber,0,Green); 
                     if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES))
                        {  
                           Print("BUY order opened : ",OrderOpenPrice());
                        }
                     else
                        {  
                           Print("Error opening BUY order : ",GetLastError());
                        }
                     OrderModify(OrderTicket(),OrderOpenPrice() ,0,Ask+tp*Point,0,Green);
                     line2trades = 1;
                     line2comment = OrderComment();
                     return;
                  } 
      
            if  ((line1trades<1) && (StochBuyLine>=StochSellLine && StochBuyLine<=12)  && ( (Open[0] < B_Line1 && Close[0] >= B_Line1)||(Open[0] > B_Line1 && Close[0] <= B_Line1)))
                  {  
                     tp = 0;
                     LotSize= 0;
                     LotSize = LotSize();
                     rand = MathRand();
                     tp = (takeprofitlower + ((takeprofitupper-takeprofitlower)*(rand/32767)));
                     tp = NormalizeDouble(tp,0); 
                     ticket = OrderSend(Symbol(),OP_BUY,LotSize, Ask, 3, 0, 0, "Coach Line1Buy",MagicNumber,0,Green); 
                     if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES))
                        {  
                           Print("BUY order opened : ",OrderOpenPrice());
                        }
                     else
                        {  
                           Print("Error opening BUY order : ",GetLastError());
                        }
                     OrderModify(OrderTicket(),OrderOpenPrice() ,0,Ask+tp*Point,0,Green);
                     line1trades = 1;
                     line1comment = OrderComment();
                     return;
                  } 
              return;    
          }
          else 
         {
            if  ((line4trades<1) && (StochSellLine>=StochBuyLine && StochSellLine>=88)  && ( (Open[0] < S_Line4 && Close[0] >= S_Line4)||(Open[0] > S_Line4 && Close[0] <= S_Line4)))
                  {  
                     tp = 0;
                     LotSize= 0;
                     LotSize = LotSize();
                     rand = MathRand();
                     tp = (takeprofitlower + ((takeprofitupper-takeprofitlower)*(rand/32767)));
                     tp = NormalizeDouble(tp,0); 
                     ticket = OrderSend(Symbol(),OP_SELL,LotSize*6, Bid, 3, 0, 0, "Coach Line4Sell",MagicNumber,0,Red); 
                     if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES))
                        {  
                           Print("SELL order opened : ",OrderOpenPrice());
                        }
                     else
                        {  
                           Print("Error opening SELL order : ",GetLastError());
                        }
                     OrderModify(OrderTicket(),OrderOpenPrice() ,0,Bid-tp*Point,0,Red);
                     line4trades = 1;
                     line4comment = OrderComment();
                     return;
                  } 
                       
      
            if  ((line3trades<1) && (StochSellLine>=StochBuyLine && StochSellLine>=88)  && ( (Open[0] < S_Line3 && Close[0] >= S_Line3)||(Open[0] > S_Line3 && Close[0] <= S_Line3)))
                  {  
                     tp = 0;
                     LotSize= 0;
                     LotSize = LotSize();
                     rand = MathRand();
                     tp = (takeprofitlower + ((takeprofitupper-takeprofitlower)*(rand/32767)));
                     tp = NormalizeDouble(tp,0); 
                     ticket = OrderSend(Symbol(),OP_SELL,LotSize*3, Bid, 3, 0, 0, "Coach Line3Sell",MagicNumber,0,Red); 
                     if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES))
                        {  
                           Print("SELL order opened : ",OrderOpenPrice());
                        }
                     else
                        {  
                           Print("Error opening SELL order : ",GetLastError());
                        }
                     OrderModify(OrderTicket(),OrderOpenPrice() ,0,Bid-tp*Point,0,Red);
                     line3trades = 1;
                     line3comment = OrderComment();
                     return;
                  } 

            if  ((line2trades<1) && (StochSellLine>=StochBuyLine && StochSellLine>=88)  && ( (Open[0] < S_Line2 && Close[0] >= S_Line2)||(Open[0] > S_Line2 && Close[0] <= S_Line2)))
                  {  
                     tp = 0;
                     LotSize= 0;
                     LotSize = LotSize();
                     rand = MathRand();
                     tp = (takeprofitlower + ((takeprofitupper-takeprofitlower)*(rand/32767)));
                     tp = NormalizeDouble(tp,0); 
                     ticket = OrderSend(Symbol(),OP_SELL,LotSize*2, Bid, 3, 0, 0, "Coach Line2Sell",MagicNumber,0,Red); 
                     if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES))
                        {  
                           Print("SELL order opened : ",OrderOpenPrice());
                        }
                     else
                        {  
                           Print("Error opening SELL order : ",GetLastError());
                        }
                     OrderModify(OrderTicket(),OrderOpenPrice() ,0,Bid-tp*Point,0,Red);
                     line2trades = 1;
                     line2comment = OrderComment();
                     return;
                  } 
      
            if  ((line1trades<1) && (StochSellLine>=StochBuyLine && StochSellLine>=88)  && ( (Open[0] < S_Line1 && Close[0] >= S_Line1)||(Open[0] > S_Line1 && Close[0] <= S_Line1)))
                  {  
                     tp = 0;
                     LotSize= 0;
                     LotSize = LotSize();
                     rand = MathRand();
                     tp = (takeprofitlower + ((takeprofitupper-takeprofitlower)*(rand/32767)));
                     tp = NormalizeDouble(tp,0); 
                     ticket = OrderSend(Symbol(),OP_SELL,LotSize, Bid, 3, 0, 0, "Coach Line1Sell",MagicNumber,0,Red); 
                     if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES))
                        {  
                           Print("SELL order opened : ",OrderOpenPrice());
                        }
                     else
                        {  
                           Print("Error opening SELL order : ",GetLastError());
                        }
                     OrderModify(OrderTicket(),OrderOpenPrice() ,0,Bid-tp*Point,0,Red);
                     line1trades = 1;
                     line1comment = OrderComment();
                     return;
                  } 
                         
         } 
      }   
return; 
} //end of function